#include "tilt.h"

#include <zephyr/bluetooth/bluetooth.h>
#include <zephyr/bluetooth/hci.h>

#include <zephyr/device.h>
#include <zephyr/devicetree.h>
#include <zephyr/drivers/sensor.h>
#include <zephyr/drivers/i2c.h>

#include <zephyr/logging/log.h>
#include <zephyr/sys/util.h>
#include <zephyr/kernel.h>



LOG_MODULE_REGISTER(tilt);

// const struct device *const sensor = DEVICE_DT_GET_ONE(st_lis2dh);


#define I2C0_NODE DT_NODELABEL(mysensor)
static const struct i2c_dt_spec dev_i2c = I2C_DT_SPEC_GET(I2C0_NODE);



void tilt_check_sensor(){
  int ret;

  const struct device *dev = device_get_binding("i2c@40004000");

  uint8_t reg_addr[2] = {0x0f, 1};
  uint8_t data[2] = {0,0};

  if (dev == NULL) {
		printk("No device found\n");
		return;
	}

// uint8_t infos[2] = {0x19, 0x0f};
  // ret = i2c_write_read(dev, 0x19, reg_addr, 0, data, 1);
  ret = i2c_write(dev, reg_addr, 1, 0x19);
  if(ret != 0){
    printk("Failed to write from I2C device address %02x at Reg. %02x \n\r", dev_i2c.addr, reg_addr[0]);
  }
  ret = i2c_read(dev, data, 1, 0x19);

  if(ret != 0){
    printk("Failed to read from I2C device address %02x at Reg. %02x \n\r", dev_i2c.addr, reg_addr[0]);
  }
  printk("Byte: %02x\n", data[0]);


  //------------------------------------------------

  // uint8_t addr[2] = 0x0f;
  // uint8_t reg_addr[2] = {0x0f, 1};

  if (!device_is_ready(dev_i2c.bus)) {
	  printk("I2C bus %s is not ready!\n\r",dev_i2c.bus->name);
  }

  // ret = i2c_reg_read_byte_dt(&dev_i2c, reg_addr[0], &data);
  ret = i2c_write_read_dt(&dev_i2c, reg_addr, 1, data, 1);
  // ret = i2c_burst_read_dt(&dev_i2c, 0x0f, data, 2);

  if(ret != 0){
    printk("Failed to read from I2C device address %02x at Reg. %02x \n\r", dev_i2c.addr, reg_addr[0]);
  }
  printk("Byte: %02x\n", data[0]);

  //-------------------------------------------

  // printk("Initializing sensor\n");
  // device_init(sensor);
  // printk("ready?\n");

	// if (sensor == NULL) {
	// 	printk("No device found\n");
	// 	return;
	// }

	// if (!device_is_ready(sensor)) {
	// 	printk("%s: is not ready.\n", sensor->name);
	// 	return;
	// }

	// printk("LIS2DH is ready\n");
}